#include <imgui.h>

#include "./controller/controller_gui.h"
#include "./controller/widget/widget_attributes.h"
#include "./core/scene.h"

namespace Splash
{

/*************/
void GuiAttributes::render()
{
    ImGui::BeginChild("##attributesArea", ImVec2(0, 0), ImGuiChildFlags_None, ImGuiWindowFlags_MenuBar);

    if (ImGui::BeginMenuBar())
    {
        if (ImGui::BeginMenu("View"))
        {
            ImGui::Checkbox("Show advanced attributes?", &_showAdvanced);
            if (ImGui::IsItemHovered())
                ImGui::SetTooltip("Show/hide advanced attributes");
            ImGui::EndMenu();
        }

        ImGui::EndMenuBar();
    }

    ImGui::BeginChild("##objectAttributes", ImVec2(0, 0), ImGuiChildFlags_Borders);
    bool isFirst = true;
    for (const auto& name : _targetObjectNames)
    {
        if (!isFirst)
        {
            ImGui::Spacing();
            ImGui::Separator();
            ImGui::Spacing();
        }
        isFirst = false;

        if (checkObjectExists(name))
        {
            ImGui::Text("Object name:");
            ImGui::SameLine();
            ImGui::PushFont(Gui::guiFonts[Gui::FontType::Bold]);
            ImGui::Text("%s", name.c_str());
            ImGui::PopFont();

            ImGui::Text("Type:");
            ImGui::SameLine();
            ImGui::PushFont(Gui::guiFonts[Gui::FontType::Bold]);
            ImGui::Text("%s", getObjectTypes()[name].c_str());
            ImGui::PopFont();

            ImGui::Text("Attributes:");
            auto attributes = getObjectAttributes(name);
            drawAttributes(name, attributes, _showAdvanced);
        }
    }

    ImGui::EndChild(); // ##objectAttributes
    ImGui::EndChild(); // ##attributesArea
}

}
