/*
 * Copyright (C) 2025 Splash authors
 *
 * This file is part of Splash.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Splash is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Splash.  If not, see <http://www.gnu.org/licenses/>.
 */

/*
 * @widget_attribute.h
 * A widget to show all of an object's attributes
 */

#ifndef SPLASH_WIDGET_ATTRIBUTES_H
#define SPLASH_WIDGET_ATTRIBUTES_H

#include <string>
#include <vector>

#include "./widget.h"

namespace Splash
{

/*************/
class GuiAttributes : public GuiWidget
{
  public:
    GuiAttributes(Scene* scene, const std::string& name)
        : GuiWidget(scene, name)
    {
    }
    void render() final;
    void setTargetObjectName(const std::vector<std::string>& names) { _targetObjectNames = names; }

  private:
    std::vector<std::string> _targetObjectNames{};
    bool _showAdvanced{false};
};

} // namespace Splash

#endif
