#include "./controller/widget/widget_logs.h"

#include <imgui.h>

#include "./utils/log.h"

namespace Splash
{

/*************/
void GuiLogs::render()
{
    ImGui::BeginChild("##logsArea", ImVec2(0, 0), ImGuiChildFlags_None, ImGuiWindowFlags_AlwaysVerticalScrollbar);

    const auto logs = Log::get().getLogs(Log::MESSAGE, Log::WARNING, Log::ERROR);
    for (const auto& [priority, log] : logs)
    {
        if (priority == Log::WARNING)
            ImGui::PushStyleColor(ImGuiCol_Text, ImVec4(0.79f, 0.46f, 0.00f, 1.00f));
        else if (priority == Log::ERROR)
            ImGui::PushStyleColor(ImGuiCol_Text, ImVec4(1.00f, 0.16f, 0.10f, 1.00f));

        ImGui::TextUnformatted(log.data());
        if (priority == Log::WARNING || priority == Log::ERROR)
            ImGui::PopStyleColor();

        if (ImGui::IsItemHovered())
            ImGui::SetTooltip("%s", log.data());
    }

    if (_logLength != logs.size())
    {
        _logLength = logs.size();
        ImGui::SetScrollHereY(1.f);
    }

    ImGui::EndChild();
}

} // namespace Splash
